using System;
using System.IO;
using System.Linq;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Diagnostics;

namespace CSharp_Shell
{

    public static class Program 
    {
        public static int index(int x, int y, int z){
            return ((y * 1000) + x) * 32 + z;
        }
        public unsafe static void Main() 
        {
           var arr = new float[32000000];
           Parallel.For(0, 32, (int d) => {
               for(int y = 0; y < 1000; y++){
                   for(int x = 0; x < 1000; x++){
                       arr[index(x, y, d)] = d;
                   }
               }
           });
           var dt = new Stopwatch();
           dt.Start();
           fixed(float* addr = &arr[0]){
               var Addr = addr;
                Parallel.For(0, 32, (int d) => {
                   for(int y = 0; y < 1000; y++){
                   for(int x = 0; x < 1000; x++){
                       *(Addr + index(x, y, d)) = d;
                   }
               }
           });
           }
           dt.Stop();
           Console.WriteLine(dt.ElapsedMilliseconds);
           dt.Reset();
           dt.Start();
           fixed(float* addr = &arr[0]){
               var Addr = addr;
           Parallel.For(0, 1000, (int y) => {
               for(int x = 0; x < 1000; x++){
                   for(int d = 0; d < 32; d++){
                       *( Addr + index(x, y, d)) = d;
                   }
               }
           });
           }
           dt.Stop();
           Console.WriteLine(dt.ElapsedMilliseconds);
        }
    }
}